{# Import this into head so that elements start hidden if they #}
{# need to be. Using the perf_busy argument to determine if  #}
{# this is an RPi client to disable self cycling. #}
{% if "perf_busy" not in request.args and "kiosk" not in request.args %}
    <style>
        .maybe-fade {
            opacity: 0;
            transition: opacity 0.5s ease-in-out;
        }

        .maybe-visible {
            opacity: 1;
        }
    </style>
    <noscript>
        <style>
            .maybe-fade {
                opacity: 1;
            }
        </style>
    </noscript>
    <script>
      document.addEventListener("DOMContentLoaded", function () {
        // slight delay in adding fade otherwise fade is skipped sometimes
        setTimeout(function () {
          document.querySelectorAll(".maybe-fade").forEach(function (elem) {
            elem.classList.add("maybe-visible")
          });
        }, 20);
        document.querySelectorAll("[show_until]").forEach(function (elem) {
          var timeRemaining = Math.max(elem.getAttribute("show_until") * 1000 - Date.now(), 1000);
          elem.timer = setTimeout(function () {
            document.querySelectorAll(".maybe-fade").forEach(function (elem) {
              elem.classList.remove("maybe-visible")
            });
            var next = document.querySelector("link[rel='next']").getAttribute("href");
            var index = document.querySelector("link[rel='index']").getAttribute("href");
            setTimeout(function () {
              if (window.location.href === index) {
                window.location.href = index;
              } else {
                window.location.href = next;
              }
            }, 500)
          }, timeRemaining);
          // "escape" cancels the automatic advance
          document.addEventListener("keydown", function (evt) {
            if (evt.keyCode === 27) {
              clearTimeout(elem.timer);
            }
          })
        });
      })
    </script>
{% endif %}
{% if "kiosk" in request.args %}
    <style>
        .kiosk-hidden {
            display: none;
        }
    </style>
{% elif "perf_busy" in request.args %}
{% else %}
    <script>
      let dateFmt = {weekday: "short", month: "short", day: "numeric"};
      let timeFmt = {hour: 'numeric', minute: 'numeric', second: 'numeric'};
      window.addEventListener("DOMContentLoaded", function () {
        document.querySelectorAll("#slide-clock").forEach(function (elem) {
          let dateElem = elem.getElementsByClassName("date")[0];
          let timeElem = elem.getElementsByClassName("time")[0];
          let updateTime = function () {
            let now = new Date();
            dateElem.textContent = Intl.DateTimeFormat("en-GB", dateFmt).format(now);
            timeElem.textContent = Intl.DateTimeFormat("en-GB", timeFmt).format(now);
            let remaining = 1000 - now.getMilliseconds();
            setTimeout(updateTime, remaining)
          };
          updateTime();
        })
      })
    </script>
{% endif %}